"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _fs = _interopRequireDefault(require("fs"));

var t = _interopRequireWildcard(require("@babel/types"));

var _pluginSyntaxFlow = _interopRequireDefault(require("@babel/plugin-syntax-flow"));

var _camelcase = _interopRequireDefault(require("camelcase"));

var _babelLooksLike = _interopRequireDefault(require("babel-looks-like"));

var _s2sHelperGetReducerCase = _interopRequireDefault(require("s2s-helper-get-reducer-case"));

var _s2sHelperGetInitialState = _interopRequireDefault(require("s2s-helper-get-initial-state"));

var _s2sUtils = require("s2s-utils");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import blog from 'babel-log'
const testBuilder = (0, _s2sUtils.template)(`
test(TEST_TITLE, () => {
  expect(reducer(initialState, actions.ACTION())).toEqual(STATE)
})
`);

var _default = () => {
  return {
    inherits: _pluginSyntaxFlow.default,
    name: 's2s-reducer-test-case',
    visitor: {
      Program(rootPath, {
        opts: {
          from
        }
      }) {
        if (!from) {
          throw new Error('required from option');
        }

        const existTestCases = [];
        rootPath.traverse({
          CallExpression(callPath) {
            if ((0, _babelLooksLike.default)(callPath, {
              node: {
                callee: {
                  type: 'Identifier',
                  name: 'test'
                }
              }
            })) {
              const testTitlePath = callPath.get('arguments')[0];
              const value = testTitlePath.get('value').node;
              existTestCases.push(value.replace('handle ', ''));
            }
          }

        });

        const code = _fs.default.readFileSync(from, 'utf8');

        const state = (0, _s2sHelperGetInitialState.default)(code) || t.nullLiteral();

        function add(actionType) {
          rootPath.pushContainer('body', [t.noop(), testBuilder({
            TEST_TITLE: t.stringLiteral(`handle ${actionType}`),
            ACTION: t.identifier((0, _camelcase.default)(actionType)),
            STATE: state
          })]);
        }

        const actions = (0, _s2sHelperGetReducerCase.default)(code);
        actions.filter(v => !existTestCases.includes(v)).forEach(add);
      }

    }
  };
};

exports.default = _default;